﻿#Concours blanc 2017

import numpy as np
import random as rd

#Partie I:

#Exercice 3:

#Question 1:

"""X=(S,I,R,D) et on a :
    f: R**4 --> R**4
       (S,I,R,D) |--> (-r*S*I,r*S*I-(a+b)*I,a*I,b*I)"""

#Question 2:

def f(X):
    """fonction définissant l'équation différentielle"""
    global r,a,b
    return np.array(-r*X[0]*X[1],r*X[0]*X[1]-(a+b)*X[1],a*X[1],b*X[1])

#Question 3:

"""Pour N=7 dt est très grand donc on calcule des valeurs approximatives non précises, alors que pour N=250 le dt est plus petit donc a priori les valeurs calculées seront
plus précises. La complexite est en o(N) par conséquent pour N=250 le temps de calcul sera plus long que pour N=7"""

#Question 4:

def f2(X,Itau):
    """ fonction définissant l'ED et Itau est la valeur I(t-p*dt) """
    global r,a,b
    return np.array([-r*X[0]*Itau,r*X[0]*Itau-(a+b)*X[1],a*X[1],b*X[1]])

  #Parametres
tmax=25
r=1
a=0.4
b=0.1
XO=np.array([0.95,0.05,0.,0.])
N=250
dt=tmax/N
t=0
X=XO
tt=[t]
XX=[X]

  #Méthode d'Euler
for i in range(N):
    t+=dt
    if t-p*dt<=0:
        Itau=XO[1]
    else:
        Itau=XX[1-i][1]
    X+=dt*f2(X,Itau)
    tt.append(t)
    XX.append(X)

