﻿# -*- coding:utf-8 -*-

from math import *
import numpy as np
from random import *
import time
import matplotlib.pyplot as plt

#Questions I.A) :

""" Un chemin d'exploration est composé de n points différents pour cette fonction, on va donc utiliser une boucle while """

def générer_PI(n,cmax):
    explo=[]
    while len(explo)<n:
        x=randint(0,cmax)
        y=randint(0,cmax)
        if [x,y] not in explo:
            explo.append([x,y])
    return explo

#print(générer_PI(6,36))

""" Les arguments doivent être strictement positifs et doivent être entiers. De plus tous les points d'intérêt à explorer ddoivent être distincts,
ainsi n<=(cmax+1)x(cmax+1)   ( nbr de choix pour x ) x ( nbr de choix pour y ) """

def position_robot():   #en attente de construction
    return (3,4)

def calculer_distances(PI):   #les points sont numérotés de 1 à n**2 par ligne
    n=len(PI)
    dist=np.zeros((n+1,n+1))
    pos=position_robot()  #tuples ~~ listes
    for i in range(n):
        for j in range(i):   #On remplit la moitié ( un peu plus ) du tableau car dist[i,j]=dist[j,i]
            distance=sqrt((PI[i,0]-PI[j,0])**2 + (PI[i,1]-PI[j,1])**2)
            dist[i,j]=distance
            dist[j,i]=dist[i,j]
        distance_initiale=((PI[i,0]-pos[0])**2 + (PI[i,1]-pos[1])**2)
        dist[i,n]=distance_initiale
        dist[n,i]=dist[i,n]
    return dist

#print(calculer_distances(générer_PI(6,54)))   #petit bug sur distance [i,n]

#Questionss I.B) :

def F1(photo):
    n=photo.min()
    b=photo.max()
    h=np.zeros(b-n+1,np.int64)
    for p in photo.flat:
        h[p-n]+=1
    return h

def sélectionner_PI(photo,imin,imax):
    h=[]
    for x in photo.flat:
        for y in photo.flat:
            if photo[x][y]<=imax and photo[x][y]>=imin:
                h.append([x,y])

#Questions I.C) :

""" SELECT EX_NUM
    FROM EXPLO
    WHERE EX_FIN='NULL' AND EX_DEB!='NULL' """

""" Soit numero, le numéro de l'exploration connue

    SELECT PI_NUM,PI_X,PI_Y
    FROM PI
    WHERE EX_NUM=numero """

""" SELECT (MAX(PI_Y)-MIN(PI_Y))*(MAX(PI_X)-MIN(PI_X))
    FROM PI
    JOIN EXPLO ON EXPLO.EX_NUM=PI.EX_NUM
    WHERE EX_FIN!='NULL' AND EX_DEB!='NULL' """

""" codage sur 64bits ???
Il vient alors qu'il y a n=2**64 - 1 entiers donc environ une capacité de srockage en surface de
n**2 ~~ 3.4.10**26 km carré """

""" SELECT COUNT(IN_NUM),SUM(IT_DUR)
    FROM INTYP
    JOIN ANALY ON INTYP.TY_NUM=ANALY.TY_NUM
    WHERE INTYP.TY_NUM=ANALY.TY_NUM
    JOIN EXPLO ON ANALY.EX_NUM=EXPLO.EX_NUM
    WHERE EX_DEB!='NULL' AND EX_FIN='NULL' """   #la 3ieme ligne de la requete permet sélectionner toutes les utilisations des intruments de l'exploration en cours

#Questions II.A) :

def longueur_chemin(chemin,d):
    n=len(chemin)
    dist_tot=0
    for i in range(1,n):
        dist_tot+=d[i-1,i]
    return dist_tot

def normaliser_chemin(chemin,n):
    chemin_norm=[]
    l=len(chemin)
    for i in range(l):
        if chemin[i] not in chemin_norm and (0<=chemin[i][1]<n and 0<=chemin[i][0]<n):
            chemin_norm.append(chemin[i])
    for i in range(n):
        for j in range(n):
            if [i,j] not in chemin_norm:
                chemin_norm.append([i,j])
    return chemin_norm

#print(normaliser_chemin([[1,2],[2,3],[2,3]],6))   #Ok fonctionne ccorrectement

#Questions II.B) :

""" on n possibilités pour x au début de même pour y, donc on a (n)**2, par récurrence immédiate
on montre qu'il y a (n)! ** 2 chemins différents passant exactement unne fois par chacun des points"""

""" Il doit être encore utilisable mais va commencer à être long à éxécuter car on a 20! ** 2 possibilités,
l'algorithme va planter ( cf complexité en O(n!**2) )"""

#Questions II.C) :

def plus_proche_voisin(d):  #le chemin doit englober tous les points de (0:n-1,0:n-1) soit n**2 points à placer
    chemin=[]               #On va choisir un point initial au hasard et appliquer l'algo
    n=len(d)
    point_init=(randint(0,n-1),randint(0,n-1))
    chemin.append(point_init)
    num_PI=n*point_init[0]+point_init[1]+1    #en effet dans d les PI sont répérés par le numéro du PI allant de 0 à n**2 -1
    while len(chemin)!=n**2:
        dist_min=d[num_PI-1][num_PI-2] #car il se peut que num_PI-1==0, ceci est une distance minimale de pivot
        ind_mini=num_PI-2
        for i in range(n):
            for j in range(i):
                                    #à compléter

""" La compléxité est en O( complexité(plus_poche_voisin) + complexité(calculer_distances), or sachant que
plus_proche_voisin a une complexité en O(n**3) et que calculer_distances a une complexité en O(n**2) donc la complexité de l'algo est en O(n**3)  """

""" On a 3 points ... """


#Questions III.A) :

def creer_population(m,d):
    individus=[]
    n=len(d)
    while len(individus)<m:
        chemin=[]
        for i in range(n):
            chemin.append([randint(0,n),randint(0,n)])
        chemin_norm=normaliser_chemin(chemin,n)  #à voir si on voulait un chemin contenant des doublons
        longueur=longueur_chemin(chemin_norm,d)
        individus.append((longueur,chemin_norm))
    return individus

#Questions III.B) :

def reduire(p):
    n=len(p)
    if n!=1:
        if n%2==0:
            m=n//2          #Pour obtenir la moitié
        else:
            m=(n-1)//2      #A voir ce qu'est la moitié pour n impair ...
        for k in range(m):
            list_long=[]
            for l in range(n-k):
                list_long.append(p[l][0])  #On crée une liste représentant l'ensemble des longeurs des individus afin d'éliminer plus facilement les plus longs chemins
            maxi=list_long[0]
            ind_maxi=0
            for i in range(n-k):
                if list_long[i]>maxi:
                    maxi=list_long[i]
                    ind_maxi=i
            del a[ind_maxi] #supprimer la ligne d'indice ind_maxi

#Questions III.C) :

def muter_chemin(c):
    n=len(c)
    a=randint(0,n-1)
    b=randint(0,n-1)
    while a==b:
        b=randint(0,n-1)
    c[a],c[b]=c[b],c[a]

def muter_population(p,proba,d):
    n=len(p)
    for k in range(n):
        proba2=random()
        if proba2<=proba:  #l'event mutation a été réalisé --> on l'active
            chemin=p[k][1]
            muter_chemin(chemin)
            p[k]=[longueur_chemin(chemin,d),chemin]

#Questions III.D) :

def croiser(c1,c2): #c1 et c2 sont déjà normaliser il suffit de prendre n=max(max(c1),max(c2)) et appliquer la fonction normaliser
    n1=len(c1)
    n2=len(c2)
    c=c1[:n1//2]+c2[n2//2:]
    max1=max(c1)
    max2=max(c2)
    m=max(max1,max2)
    normaliser_chemin(c,m)

def nouvelle_generation(p,d):
    m=len(p)
    new_gen=[]
    for i in range(m):
        if i!=m-1:
            chemin=croiser(p[i][1],p[i+1][1])
            long=longueur_chemin(chemin,d)
            new_gen.append(long,chemin)
        else:
            chemin=croiser(p[i][1],p[0,1])
            long=longueur_chemin(chemin,d)
            new_gen.append(long,chemin)
    return p+new_gen

#Questions III.E) :

def algo_genetique(PI,m,proba,g):
    d=calculer_distances(PI)
    p=creer_population(m,d)
    for k in range(g): #on va générer la g-ième géné avec les mutations etc...
        reduire(p)
        muter_population(p,proba,d)
        nouvelle_generation(p,d)
    n=len(p)
    mini=p[0][0]
    chemin_mini=p[0][1]
    ind_mini=0
    for i in range(n):
        if p[i][0]<mini:
            mini=p[i][0]
            chemin_mini=p[i][1]
            ind_mini=i
    return mini,chemin_mini










