﻿# Créé par Alexandre, le 13/09/2017 en Python 3.2
from math import *
import matplotlib.pyplot as plt
import numpy as np

#Rappel du cours de PCSI

to=0
tmax=10
vo=5
vlim=2
tau=1
h=0.00001
n=floor((tmax-to)/h)

def f(x):
    return (vlim-x)/tau

V=np.zeros(n)
T=np.zeros(n)

V[0]=vo
T[0]=to

for i in range(n-1):
    T[i+1]=to + (i+1)*h
    V[i+1]=V[i] + h*f(V[i])


def sol_approchee(t):
    return (vo-vlim)*np.exp(to/tau)*np.exp(-t/tau)+vlim

plt.figure("solution Exacte et mÃ©thode Euler ")
plt.title('(E) tau dv/dt + v = vlim, tau={0}, vlim={1}, t0={2},v0={3}, t1={4}, h={5}'.format(tau,vlim,to,vo,tmax,h))
plt.xlabel("t (temps)")
plt.ylabel("v(t)")
plt.plot(T,V,linestyle='--',color='r')
plt.plot(T,sol_approchee(T),linestyle='-.',color='b')
plt.legend(('Methode d Euler','Solution Exacte'))
plt.show()


#Pendule simple

lambdaa=1
t0=0
omega0=8
theta0=1
vtheta0=1
T=5
h=0.001
n=floor(T/h)   #Conditions imposées

def F(Y):
    return np.array([Y[1],-2*lambdaa*Y[1]-omega0**2*np.sin(Y[0])])  #Tableau

YY=np.zeros((2,n))  #Tableu à deux dimensions
T=np.zeros(n)

YY[:,0]=[theta0,vtheta0]
T[0]=0

for i in range(n-1):
    T[i+1]=T[i]+h   #Ti+1 devient TI + le pas h
    YY[:,i+1]=YY[:,i]+h*F(YY[:,i])  #YYi+1 est égal au YYi +h*F(YYi)  cf DL 1

plt.figure("Evolution de theta")
plt.plot(T,YY[0])
plt.figure("portrait de phase")
plt.plot(YY[0],YY[1])
plt.show()


#Réactions chimiques

a0=1
k1=0.5
k2=1
h=0.02
t0=0
t1=5
n=floor((t1-t0)/h)  #conditions imposées

def F_a(x):
    return np.array(-k1*x[0],-k2*x[1]+k1*x[0],k2*x[1])

X=np.array((n,n,n))
T=np.array(n)

#X[:,0]=[a0,0,0]  #CI     ## Check taille de X
T[0]=t0

for i in range(n-1):
    X[:,i+1]=X[:,i]+F_a(X[:,i])
    T[:,i+1]=T[:,i]+h

def a(t):
    return a0*np.exp(-k1*t)

def b(t):
    return ((k1*a0)/(k2-k1))*(np.exp(-k1*t)-np.exp(-k2*t))

def c(t):
    return a0-b(t)-a(t)

plt.figure("RÃ©actions chimiques successives")
plt.xlabel(" t(temps)")
plt.ylabel("DiffÃ©rnetes concentrations")
plt.title("RÃ©actions chimiques successives.A->B->C. k1={0},k2={1},t0={2},t1={3},h={4}".format(k1,k2,t0,t1,h))
plt.plot(T,YY[0],color='b')
plt.plot(T,YY[1],linestyle='--',color='r')
plt.plot(T,YY[2],linestyle='-.',color='g')
plt.plot(T,b(T),linestyle='-',color='k')
plt.plot(T,a(T),linestyle='-',color='y')
plt.plot(T,c(T),linestyle='-',color='p')
plt.legend(('Concentration de A','Concentration de B','Concentration de C','Valeur exacte de B','Valeur exacte de A','Valeur exacte de C'))
#plt.show()



