﻿# Equations de la chaleur


import matplotlib.pyplot as plt

#1
Longueur=1
duree=10**10
k=0.01
h=0.01
alpha=0.0001
#2
Nx=int(Longueur/h)
Nt=int(duree/k)
#3
T=[[1 if j>=Nx//2 else 0 for j in range (Nx)]for i in range (Nt)]
#4
T[0]=[1 if j>=Nx//2 else 0 for j in range(Nx)]
#5
for t in range (0,Nt-1):
    for x in range(1,Nx-1):
        T[t+1][x]=T[t][x]+alpha*k*(T[t][x+1]-2*T[t][x]+T[t][x-1])/(h*h)
#6
dist=[i*h for i in range(Nx)]

#Création des figures
#7
plt.figure(1)
plt.plot(dist,T[int(Nt/4)],'k--',linewidth=2)
plt.plot(dist,T[int(Nt/2)],'k-.',linewidth=2)
plt.plot(dist,T[int(3*Nt/4)],'k:',linewidth=2)
plt.plot(dist,T[-1],'k',linewidth=2)
plt.plot(dist,T[0],'k')

plt.xlabel('longueur (m)',fontsize=14)
plt.ylabel('température (°C)',fontsize=14)
plt.legend(('t=125 s','t=250s','t=375s','t=500s'))

#8
plt.figure(2)
plt.imshow(T)
plt.colorbar()
plt.axis('tight')
plt.ylabel('durée (seconde)',fontsize=14)
plt.xlabel('longueur (m)',fontsize=14)

#Affichage des figures
plt.show()
