﻿#Moddélisation Centrale 2015

from math import *
import numpy as np
import matplotlib.pyplot as plt
from random import *

# I Quelques fonctions utilitaires:

""" [1,2,3]+[4,5,6] = [1,2,3,4,5,6] """
""" 2*[1,2,3] = [1,2,3,1,2,3] """

test=[1,2,3]
test2=[4,5,6]

def smul(L,k):
    n=len(L)
    M=[]
    for i in range(n):
        M.append(k*L[i])
    return M

def smul2(L,k):
    return [k*i for i in L]

#print(smul(test,2))
#print(smul2(test,2))

def vsom(L1,L2):
    n=len(L1)
    L=[]
    for i in range(n):
        L.append(L1[i]+L2[i])
    return L

def vdif(L1,L2):
    n=len(L1)
    L=[]
    for i in range(n):
        L.append(L1[i]-L2[i])
    return L

def vdif2(L1,L2):
    return vsom(L1,smul(L2,-1))

#print(vdif(test,test2))
#print(vdif2(test,test2))

# II Etude de schémas numériques :

"""(II.1) <--> t appartient à I :  z'(t)=f(y(t))

n>=1 Jn=[|0,n-1|], soit i appartenaant à [|0,n-2|]:
    y(ti + 1) = y(ti) + intégrale de ti à ti+1 y'(t)dt
    or y'(t) = z(t)

    z(ti + 1) = z(ti) + intégrale de ti à ti+1 f(y(t))dt

y(ti + 1)= y(ti) + h*z(ti)   # h=(ti+1 - ti)
z(ti + 1)= z(ti) + h*f(y(ti)) """

w=2*pi
z0=0
y0=3
tmin=0
tmax=3
n=100
h=(tmax-tmin)/(n-1)

def f(x):
    return -1*w**2*x

def euler(h,z0,y0,n):
    TT=[]
    TT.append(tmin)
    ZZ=[]
    ZZ.append(z0)
    YY=[]
    YY.append(y0)
    for i in range(n-1):
        TT.append(tmin+i*h)
        ZZ.append(ZZ[i]+h*f(YY[i]))
        YY.append(YY[i]+h*ZZ[i])
    return ZZ,YY,TT

""" y''(t) = -w**2*y(t)
    y'(t)*y''(t) = -w**2*y'(t)y(t)
    0.5*d(y'(t)**2)/dt=-w**2*0.5*d(y(t)**2)/dt
    0.5*y'(t)**2 + 0.5*w**2*y(t)**2 = E (= constante)

Soit i appartenant à Jn
 2*(Ei+1 - Ei) = z(i+1)**2 + w**2*y(i+1) - ( z(i)**2 + w**2*y(i))   #z(i) et y(i) valeur approché de z et y en ti
 2*(Ei+1 - Ei) = ( z(i) - w**2*y(i)*h )**2 + w**2*( y(i) + h*z(i) )**2 - ( z(i)**2 + w**2*y(i))
 2*(Ei+1 - Ei) = z(i)**2 - 2w**2*h*z(i)*y(i) + w**4*h**2*y(i)**2 + w**2*y(i)**2 + 2w**2*y(i)*h*z(i) + w**2*h**2*z(i)**2 - z(i)**2 - w**2*y(i)
                    /                                                    /                                                   /         /
 2*(Ei+1 - Ei) = -2w**2*z(i)y(i)*h + h**2*w**4*y(i)**2 + 2*w**2*y(i)*z(i)*h + h**2*z(i)**2
                    /                                      /
 2*(Ei+1 - Ei) = h**2*w**2 ( w**2*y(i)**2 + z(i)**2 )
 2*(Ei+1 - Ei) = h**2*w**2 Ei

conservation de E <--> Ei+1-Ei = 0

équation donnant E: z**2/2 +w**2y*2/2  --> équation d'une ellipse"""

SOL=euler(h,z0,y0,n)

plt.plot(SOL[1],SOL[0])
#plt.show()

""" On remarque sur le graphe que z=f(y) diverge, fuit le centre
évolution dans le sens inverse trigo en effet lorsque z'<0 --> y diminue et inversement c'est donc adéquat au graphe"""

def verlet(y0,z0,h,n):
    YY=[]
    ZZ=[]
    ZZ.append(z0)
    YY.append(y0)
    for i in range(n-1):
        YY.append(YY[i]+h*ZZ[i]+h**2/2*f(YY[i]))
        ZZ.append(ZZ[i]+h/2*(f(YY[i])+f(YY[i+1])))
    return YY,ZZ

""" 2(Ei+1 - Ei) = ((zi+h/2*(f(yi)+f(y+1))**2 + w**2*(yi + h*zi +h**2/2*f(yi))**2 - ( (zi-1 +h/2*(f(y+1)+f(yi))**2 + w**2*(yi-1 + h*zi + h**2/2*f(yi+1))**2 )
                                                        ici on a du h**3

il vient donc:              Ei+1 - Ei = O(h**3) """

SOL_Verlet=verlet(y0,z0,h,n)

plt.plot(SOL_Verlet[0],SOL_Verlet[1])
#plt.show()

""" cercle fermé = convergence
        conservation de E """

""" le schéma de Verlet est meilleur"""

# III Problème à N corps:

""" Fj = Sigma(1,k,k != j) Fkj"""

G=6.67*10**-11

def force2(m1,p1,m2,p2):
    P=vdif2(p1,p2)
    norme=0
    for k in range(3):
        norme+= P[k]**2
    norme=norme**0.5
    mul=G*m1*m2/norme**3
    return(smul(P,mul))

def forceN(j,m,pos):
    som_forceN=[0,0,0]
    n=len(m)
    for k in range(n):
            if k!=j:
                pivot=force2(m[j],pos[j],m[k],pos[k])
                for i in range(3):
                    som_forceN[i]+=pivot[i]
    return som_forceN

N=10
test_masse=[uniform(0,10**30) for k in range(N)]
test_position=[[uniform(-10**6,10**6) for i in range(3)]for k in range(N)]
#j appartient à [|0,N-1|]

#print(forceN(randint(0,N-1),test_masse,test_position))

""" position[i] contient la postion des corps à l'instant i selon x,y,x
    vitesse[i] contient la vitesse des corps à l'instant i selon x,y,z """

test_vitesse=[[uniform(0,100) for i in range(3)]for k in range(N)]
h=10**-6

def pos_suiv(m,pos,vit,h):
    n=len(m)
    position_final=[0,0,0]
    for j in range(n):
        pivot=vsom(pos[j],smul(vit[j],h))
        pivot2=smul(forceN(j,m,pos),h**2/(2*m[j]))
        result=vsom(pivot,pivot2)
        for k in range(3):
            position_final[k]=result[k]
    return position_final,pos[j]

print(pos_suiv(test_masse,test_position,test_vitesse,h))

def etat_suiv(m,pos,vit,h):
    position_final=pos_suiv(m,pos,vit,h)
    vitesse_final=[0,0,0]
    n=len(m)
    for j in range(n):
        F=vsom(forceN(j,m,pos),forceN(j,m,position_final))
        for k in range(3):
            vitesse_final[k]+=vsom(vit[j],smul(F,h/(2*m[j])))[k]
    return (position_final,vitesse_final)

print(etat_suiv(test_masse,test_position,test_vitesse,h))





