﻿import numpy as np
from math import *
import matplotlib.pyplot as plt

#Exercice 1:

def U_n(a,n):
    if n==0:
        return a
    else:
        u_n=U_n(a,n-1)
        return 0.5*u_n+a/(2*u_n)

#print(U_n(2,10))

#Exerice 2:

def u(n):
    if n==0:
        return 1
    else:
        u_n=u(n-1)
        v_n=v(a,n-1)
        return 2*u_n*v_n/(u_n+v_n)

def v(a,n):
    if n==0:
        return a
    else:
        return (u(n-1)+v(a,n-1))/2

def uetv(a,n):
    if n==0:
        return 1,a
    else:
        ur,vr=uetv(a,n-1)
        return 2*ur*vr/(ur+vr),0.5*(ur+vr)


#print(uetv(2,3))
#print(u(5))
#print(v(a,10))

#Exercice 3:

def factorielle(n):
    if n<0:
        return 0
    elif n==0:
        return 1
    else:
        return n*factorielle(n-1)

def coeffBinomial(n,p):
    if p>n :
        return 0
    elif p==n :
        return 1
    elif p<0 or n<0:
        return 0
    elif p==0:
        return 1
    elif p==1:
        return n
    else:
        return n/p*((factorielle(n-1))/(factorielle(p-1)*factorielle(n-p)))

def coeffBinomial1(n,p):
    if p>n:
        return 0
    elif p==n:
        return 1
    elif p<0 or n<0:
        return 0
    elif p==0:
        return 1
    elif p==1:
        return n
    else:
        return coeffBinomial1(n-1,p)+coeffBinomial1(n-1,p-1)

def coeffBinomial2(n,p):
    if p>n:
        return 0
    elif p==n:
        return 1
    elif p<0 or n<0:
        return 0
    elif p==0:
        return 1
    elif p==1:
        return n
    else:
        return n/p*coeffBinomial2(n-1,p-1)

#print(coeffBinomial(8,4))
#print(coeffBinomial1(8,4))
#print(coeffBinomial2(8,4))

#Exercice 4:

cpt1=0

def hanoi(n,dep,arr,int): #cpt1 représente le nombre d'étape de la solution
    global cpt1
    if n>0:
        hanoi(n-1,dep,int,arr)
        print("deplace",dep,"sur",arr)
        cpt1+=1
        hanoi(n-1,int,arr,dep)
    return cpt1

"""Complexité en o(2**n)"""
"""n==1 ok
#Si optimal au rang n alors au rang (n+1) la stratégie optimale repose sur le fait que l'on puisse déplacer le disque de départ sur larrivéé : 1 mouv.
Pour faire cela il faut avoir déplacer les n anneaux du dessus ce qui se fait avec la stratégie optimale du rang n (HR). D'où 2**n -1 étapes"""

cpt2=0

def hanoi2(n,i,j):
    global cpt2
    if n==0:
        None
    else:
        int=6-i-j
        hanoi2(n-1,i,int)
        print("bouger un anneau de ",i,"vers",j)
        cpt2+=1
        hanoi2(n-1,int,j)
    return cpt2

#print(hanoi(3,1,3,2))
#print(hanoi2(3,1,3))

#Exercice 5:

def puissbete(x,n):
    if n==0:
        return 1
    else :
        return x*puissancefloat(x,n-1)

#print(puissbete(3.48,5))

def puissancemalin(x,n):
    if n==0:
        return 1
    elif n%2==0:
        return puissancemalin(x,n/2)**2
    else:
        return x*puissancemalin(x,n//2)**2

#print(puissancemalin(3.48,5))

#Exercice 6:

cpt=0

def F_n(n):
    global cpt
    cpt+=1
    if n==0:
        return 0
    elif n==1:
        return 1
    else:
        return F_n(n-1)+F_n(n-2)

def fiboAux(n,fn,fnplus1):
    if n==0:
        return fn
    elif n==1:
        return fnplus1
    else:
        return fiboAux(n-1,fnplus1,fn+fnplus1)

def Fibodble(n):
    return fiboAux(n,fk,fkplus1),fiboAux(n,fkplus1,fkplus1+fk)

cpt3=0

def cache_memo2(n):  #dico memo
    cache={}
    return memoization(n,cache)

def memoization(n,cache):
    global cpt3
    cpt3+=1
    if n not in cache:
        if n<2:
            cache[n]=n
        else:
            cache[n]=memoization(n-1,cache)+memoization(n-2,cache)
    else:
        return cache[n]
    return cache[n]

cpt4=0

def Fib_memo(n,cache):  #Liste memo tricherie
    global cpt4
    cpt4+=1
    if n in cache and n-1 in cache:
        return cache[n]
    else:
        if n<2:
            return n
        else:
            return cache[n-1]+cache[n-2]

def cache_memo(n):
    cache=np.zeros(n+1)
    for i in range(n+1):
        cache[i]=Fib_memo(i,cache)
    return cache

def fibmo(n):
    L=[0,1]+1000*[-1]
    def fibor(n):
        global memo
        if L[n]!=-1:
            return L[n]
        else:
            return fibor(n-1)+fibor(n-2)
    result=fibor(n)
    if L[n]!=-1:
        L[n]=result
    return result

fk=0
fkplus1=1
#print(F_n(20))
#print(fiboAux(5,fk,fkplus1))
#print(Fibodble(10))
#print(cache_memo(500))
#print(cache_memo2(500))
#print(fibmo(50))


#Exercice 7:

def f(n):
    return 1/n**3

def somme(f,n):
    if n==0:
        return 0
    else:
        return f(n)+somme(f,n-1)

#print(somme(f,500))

cpt51=0

def nbr_Catalan(n):
    global cpt51
    cpt51+=1
    if n==0 or n==1:
        return 1
    else :
        c=0
        for i in range(n):
            c+=nbr_Catalan(i)*nbr_Catalan(n-1-i)
        return c

cpt52=0

"""def cache_Catalan2(n):
    cache_Catal={}
    return memo_Catalan2(n,cache_Catal)

def memo_Catalan2(n,cache):
    global cpt52
    cpt52+=1
    if n not in cache:
        if n<2:
            cache[n]=n
        else:
            for k in range(n):
                cache[n]+=memo_Catalan2(k,cache)*memo_Catalan2(n-1-k,cache)
    else:
        return cache[n]"""

cpt5=0

def cache_Catalan(n):
    cache_cat=[]
    for i in range(n+1):
        cache_cat.append(memo_Catalan(i,cache_cat))
    return cache_cat

def memo_Catalan(n,cache):
    global cpt5
    cpt5+=1
    if n in cache and n-1 in cache:
        return cache[n]
    elif n==0 or n==1:
        return 1
    else:
        c=0
        for k in range(n):
            c+=cache[k]*cache[n-1-k]
        return c

#print(nbr_Catalan(7))
#print(cache_Catalan(7))
#print(cache_Catalan2(7))

#Exercice 8:

def calc_zc(za,zb):
    #(zb-zc)/(za-zc)=exp(i*pi/2) angle droit en C
    return (1+1j)/2*(zb-1j*za)

z1=1j
z2=1
z3=calc_zc(z1,z2)

def distance_complexe(za,zb,zc):
    if sqrt((za.real**2-zc.real**2)+(za.imag**2-zc.imag**2))==sqrt((zb.real**2-zc.real**2)+(zb.imag**2-zc.imag**2)):
        return True

#print(distance_complexe(z1,z2,z3))

def Dragon(n,za,zb): #renvoie une liste
    if n==0:
        return [za,zb]
    else:
        zc=calc_zc(za,zb)
        conc1=Dragon(n-1,za,zc)
        conc2=Dragon(n-1,zc,zb)
        return conc1+conc2

def traceDepuisC(L):
    abscisse=[]
    ordonee=[]
    for z in L:
        abscisse.append(z.real)  #abs part reelle
        ordonee.append(z.imag)   #ord part imaginaire
    plt.plot(abscisse,ordonee)
    plt.show()

def Affichage(n):
    za=1/2+sqrt(5)/2j
    zb=1/2-sqrt(5)/2j
    traceDepuisC(Dragon(n,za,zb))

def Affichage_succes(n):
    for i in range(n) :
        print(Affichage(i))

#print(Affichage_succes(20))

#Exercice 9:

def f_LV(x,p):
    if x==0:
        return 0
        return "looser"
    elif x==1:
        return 1
        return "winner"
    elif x<=0.5 and x>0:
        return p*f_LV(2*x,p)
    elif x<1 and x>0.5:
        return p+(1-p)*f_LV(2*x-1,p)
    elif x<0:
        return "tu es fauché"
    else:
        return "tricheur"

def graphe_LV(h,p):
    Lx=[]
    Ly=[]
    x=0
    while x<=1:
        Lx.append(x)
        Ly.append(f_LV(x,p))
        x+=h
    plt.plot(Lx,Ly)
    plt.show()

#print(f_LV(0.00,1))

def influence_p(h):
    p=0
    while p<=1:
        graphe_LV(h,p)
        p+=h

#print(graphe_LV(0.001,0.5))
#print(influence_p(0.05))


